import { Image, Text, View } from "@tarojs/components"
import { memo, useState } from "react"
import styles  from './index.module.scss'
import classnames from "classnames";
type Param = {
    title: string,
    time: string,
    tag: string,
    desc: string
}
export default memo(({list = []}:{list?:Param[]}) => {
    const [showMore, setShowMore] = useState(false)
    const changeMore = () => {
        setShowMore(() => !showMore)
    }
    list = [
        {title:'待配布', time:'2022-04-24 09:08', tag:'已接单', desc:'仓库正在为你配布...'},
        {title:'待配布', time:'2022-04-24 09:08', tag:'已接单', desc:'仓库正在为你配布...'},
        {title:'待接单', time:'2022-04-24 09:08', tag:'已提交', desc:''},
    ]
    return (
        <View className={styles.order_flow_state}>
            <View className={classnames(styles.order_status_list, showMore&&styles.order_status_list_show)}>
                {list.map((item, index) => <View className={styles.order_status_item}>
                    {(list.length > 1)&&<View className={classnames(styles.order_status_tail, (index == 0)&&styles.order_status_tail_end)}></View>}
                    {(list.length != (index + 1))&&<View className={styles.order_status_line}></View>}
                    <View className={styles.order_status_content}>
                        <View className={classnames(styles.order_status_title, (index == 0)&&styles.order_status_select)}>{item.title}</View>
                        <View className={classnames(styles.order_status_time, (index == 0)&&styles.order_status_select)}>{item.time}</View>
                        <View className={classnames(styles.order_status_tag, (index == 0)&&styles.order_status_tag_select)}>{item.tag}</View>
                    </View>
                    <Text className={classnames(styles.order_status_des, (index == 0)&&styles.order_status_des_select)}>{item.desc}</Text>
                </View>)}
            </View>
            {(list.length > 2) && <View className={styles.more} onClick={() => changeMore()}>
                <Text>{showMore&&'收起物流详情'||'点击查看更多物流详情'}</Text>
                <Text className={classnames('iconfont icon-a-moreback', styles.miconfonts, showMore&&styles.open_miconfonts)}></Text>
            </View>}
            {/* <View className={styles.tag}>
                <Image src='./styles/image/hkfk.png' />
            </View> */}
        </View>
    )
})